# Ogre::AnimationTrack Class Reference

A 'track' in an animation sequence, ie a sequence of keyframes which affect a certain type of animable object. More...

`#include <OgreAnimationTrack.h>`

List of all members.

## Public Member Functions

| AnimationTrack (Animation *parent)
| Constructor.
| AnimationTrack (Animation *parent, Node *targetNode)
| Constructor, associates with a Node.
virtual | ~AnimationTrack ()
unsigned short | getNumKeyFrames (void) const
| Returns the number of keyframes in this animation.
KeyFrame * | getKeyFrame (unsigned short index) const
| Returns the KeyFrame at the specified index.
Real | getKeyFramesAtTime (Real timePos, KeyFrame **keyFrame1, KeyFrame **keyFrame2, unsigned short *firstKeyIndex=0) const
| Gets the 2 KeyFrame objects which are active at the time given, and the blend value between them.
KeyFrame * | createKeyFrame (Real timePos)
| Creates a new KeyFrame and adds it to this animation at the given time index.
void | removeKeyFrame (unsigned short index)
| Removes a KeyFrame by it's index.
void | removeAllKeyFrames (void)
| Removes all the KeyFrames from this track.
KeyFrame | getInterpolatedKeyFrame (Real timeIndex) const
| Gets a KeyFrame object which contains the interpolated transforms at the time index specified.
void | apply (Real timePos, Real weight=1.0, bool accumulate=false, Real scale=1.0f)
| Applies an animation track at a certain position to the target node.
Node * | getAssociatedNode (void) const
| Returns a pointer to the associated Node object (if any).
void | setAssociatedNode (Node *node)
| Sets the associated Node object which will be automatically affected by calls to 'apply'.
void | applyToNode (Node *node, Real timePos, Real weight=1.0, bool accumulate=false, Real scale=1.0f)
| As the 'apply' method but applies to a specified Node instead of associated node.
void | setUseShortestRotationPath (bool useShortestPath)
| Sets the method of rotation calculation.
bool | getUseShortestRotationPath () const
| Gets the method of rotation calculation.
void | _keyFrameDataChanged (void) const
| Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data.
bool | hasNonZeroKeyFrames (void) const
| Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out.
void | optimise (void)
| Optimise the current track by removing any duplicate keyframes.

## Protected Types

typedef std::vector< KeyFrame * > | KeyFrameList

## Protected Member Functions

void | buildInterpolationSplines (void) const

## Protected Attributes

KeyFrameList | mKeyFrames
Real | mMaxKeyFrameTime
Animation * | mParent
Node * | mTargetNode
bool | mSplineBuildNeeded
SimpleSpline | mPositionSpline
SimpleSpline | mScaleSpline
RotationalSpline | mRotationSpline
bool | mUseShortestRotationPath
| Defines if rotation is done using shortest path.

## Detailed Description

A 'track' in an animation sequence, ie a sequence of keyframes which affect a certain type of animable object.

Remarks:
  This class is intended as a base for more complete classes which will actually animate specific types of object, e.g. a bone in a skeleton to affect skeletal animation. An animation will likely include multiple tracks each of which can be made up of many KeyFrame instances. Note that the use of tracks allows each animable object to have it's own number of keyframes, i.e. you do not have to have the maximum number of keyframes for all animable objects just to cope with the most animated one.

  Since the most common animable object is a Node, there are options in this class for associating the track with a Node which will receive keyframe updates automatically when the 'apply' method is called.

  By default rotation is done using shortest-path algorithm. It is possible to change this behaviour using setUseShortestRotationPath() method.

Definition at line 54 of file OgreAnimationTrack.h.

## Member Typedef Documentation

typedef std::vector<KeyFrame*> Ogre::AnimationTrack::KeyFrameList `[protected]`

| Definition at line 165 of file OgreAnimationTrack.h.

## Constructor & Destructor Documentation

Ogre::AnimationTrack::AnimationTrack | ( | Animation * | parent | ) |

| Constructor.

Ogre::AnimationTrack::AnimationTrack | ( | Animation * | parent,
|  | Node * | targetNode
| ) |

| Constructor, associates with a Node.

virtual Ogre::AnimationTrack::~AnimationTrack | ( |  | ) | `[virtual]`

## Member Function Documentation

void Ogre::AnimationTrack::_keyFrameDataChanged | ( | void |  | ) | const

| Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data.

void Ogre::AnimationTrack::apply | ( | Real | timePos,
|  | Real | weight = 1.0,
|  | bool | accumulate = false,
|  | Real | scale = 1.0f
| ) |

Applies an animation track at a certain position to the target node.

Remarks:
  When a track has bee associated with a target node, you can eaisly apply the animation to the target by calling this method.

Parameters:

  timePos | The time position in the animation to apply.
  weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

void Ogre::AnimationTrack::applyToNode | ( | Node * | node,
|  | Real | timePos,
|  | Real | weight = 1.0,
|  | bool | accumulate = false,
|  | Real | scale = 1.0f
| ) |

| As the 'apply' method but applies to a specified Node instead of associated node.

void Ogre::AnimationTrack::buildInterpolationSplines | ( | void |  | ) | const`[protected]`

KeyFrame* Ogre::AnimationTrack::createKeyFrame | ( | Real | timePos | ) |

Creates a new KeyFrame and adds it to this animation at the given time index.

Remarks:
  It is better to create KeyFrames in time order. Creating them out of order can result in expensive reordering processing. Note that a KeyFrame at time index 0.0 is always created for you, so you don't need to create this one, just access it using getKeyFrame(0);

Parameters:

  timePos | The time from which this KeyFrame will apply.

Node* Ogre::AnimationTrack::getAssociatedNode | ( | void |  | ) | const

| Returns a pointer to the associated Node object (if any).

KeyFrame Ogre::AnimationTrack::getInterpolatedKeyFrame | ( | Real | timeIndex | ) | const

Gets a KeyFrame object which contains the interpolated transforms at the time index specified.

Remarks:
  The KeyFrame objects held by this class are transformation snapshots at discrete points in time. Normally however, you want to interpolate between these keyframes to produce smooth movement, and this method allows you to do this easily. In animation terminology this is called 'tweening'.

Parameters:

  timeIndex | The time (in relation to the whole animation sequence)

Returns:
  A new keyframe object containing the interpolated transforms. Note that the position and scaling transforms are linearly interpolated (lerp), whilst the rotation is spherically linearly interpolated (slerp) for the most natural result.

KeyFrame* Ogre::AnimationTrack::getKeyFrame | ( | unsigned short | index | ) | const

| Returns the KeyFrame at the specified index.

Real Ogre::AnimationTrack::getKeyFramesAtTime | ( | Real | timePos,
|  | KeyFrame ** | keyFrame1,
|  | KeyFrame ** | keyFrame2,
|  | unsigned short * | firstKeyIndex = 0
| ) | const

Gets the 2 KeyFrame objects which are active at the time given, and the blend value between them.

Remarks:
  At any point in time in an animation, there are either 1 or 2 keyframes which are 'active', 1 if the time index is exactly on a keyframe, 2 at all other times i.e. the keyframe before and the keyframe after.

  This method returns those keyframes given a time index, and also returns a parametric value indicating the value of 't' representing where the time index falls between them. E.g. if it returns 0, the time index is exactly on keyFrame1, if it returns 0.5 it is half way between keyFrame1 and keyFrame2 etc.

Parameters:

  timePos | The time index in seconds.
  keyFrame1 | Pointer to a KeyFrame pointer which will receive the pointer to the keyframe just before or at this time index.
  keyFrame2 | Pointer to a KeyFrame pointer which will receive the pointer to the keyframe just after this time index.
  firstKeyIndex | Pointer to an unsigned short which, if supplied, will receive the index of the 'from' keyframe incase the caller needs it.

Returns:
  Parametric value indicating how far along the gap between the 2 keyframes the timePos value is, e.g. 0.0 for exactly at 1, 0.25 for a quarter etc. By definition the range of this value is: 0.0 <= returnValue < 1.0 .

unsigned short Ogre::AnimationTrack::getNumKeyFrames | ( | void |  | ) | const

| Returns the number of keyframes in this animation.

bool Ogre::AnimationTrack::getUseShortestRotationPath | ( |  | ) | const

| Gets the method of rotation calculation.

bool Ogre::AnimationTrack::hasNonZeroKeyFrames | ( | void |  | ) | const

| Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out.

void Ogre::AnimationTrack::optimise | ( | void |  | ) |

| Optimise the current track by removing any duplicate keyframes.

void Ogre::AnimationTrack::removeAllKeyFrames | ( | void |  | ) |

| Removes all the KeyFrames from this track.

void Ogre::AnimationTrack::removeKeyFrame | ( | unsigned short | index | ) |

| Removes a KeyFrame by it's index.

void Ogre::AnimationTrack::setAssociatedNode | ( | Node * | node | ) |

| Sets the associated Node object which will be automatically affected by calls to 'apply'.

void Ogre::AnimationTrack::setUseShortestRotationPath | ( | bool | useShortestPath | ) |

| Sets the method of rotation calculation.

## Member Data Documentation

KeyFrameList Ogre::AnimationTrack::mKeyFrames `[protected]`

| Definition at line 166 of file OgreAnimationTrack.h.

Real Ogre::AnimationTrack::mMaxKeyFrameTime `[protected]`

| Definition at line 167 of file OgreAnimationTrack.h.

Animation* Ogre::AnimationTrack::mParent `[protected]`

| Definition at line 168 of file OgreAnimationTrack.h.

SimpleSpline Ogre::AnimationTrack::mPositionSpline `[mutable, protected]`

| Definition at line 176 of file OgreAnimationTrack.h.

RotationalSpline Ogre::AnimationTrack::mRotationSpline `[mutable, protected]`

| Definition at line 178 of file OgreAnimationTrack.h.

SimpleSpline Ogre::AnimationTrack::mScaleSpline `[mutable, protected]`

| Definition at line 177 of file OgreAnimationTrack.h.

bool Ogre::AnimationTrack::mSplineBuildNeeded `[mutable, protected]`

| Definition at line 175 of file OgreAnimationTrack.h.

Node* Ogre::AnimationTrack::mTargetNode `[protected]`

| Definition at line 169 of file OgreAnimationTrack.h.

bool Ogre::AnimationTrack::mUseShortestRotationPath `[mutable, protected]`

| Defines if rotation is done using shortest path. Definition at line 180 of file OgreAnimationTrack.h.

The documentation for this class was generated from the following file:

- OgreAnimationTrack.h

Copyright © 2000-2005 by The OGRE Team
Last modified Sun Nov 20 12:36:19 2005